Properties

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class Properties

    java.lang.Object
      java.util.Dictionary
          java.util.Hashtable
              java.util.Properties

All Implemented Interfaces:
  Serializable, Cloneable, Map

Direct Known Subclasses:
  Provider

    public class Properties

extends Hashtable

The `Properties` class represents a persistent set of properties. The `Properties` can be saved to a stream or loaded from a stream. Each key and its corresponding value in the property list is a string.

A property list can contain another property list as its "defaults"; this second property list is searched if the property key is not found in the original property list.

Because `Properties` inherits from `Hashtable`, the `put` and `putAll` methods can be applied to a `Properties` object. Their use is strongly discouraged as they allow the caller to insert entries whose keys or values are not `Strings`. The `setProperty` method should be used instead. If the `store` or `save` method is called on a "compromised" `Properties` object that contains a non-`String` key or value, the call will fail.

When saving properties to a stream or loading them from a stream, the ISO 8859-1 character encoding is used. For characters that cannot be directly represented in this encoding, Unicode escapes are used; however, only a single 'u' character is allowed in an escape sequence. The native2ascii tool can be used to convert property files to and from other character encodings.

Since:
  JDK1.0
Version:
  1.61, 05/03/00
Author:
  Arthur van Hoff, Michael McCloskey
See Also:
  native2ascii tool for Solaris, native2ascii tool for Windows, Serialized Form

Constructor Summary
`Properties()` Creates an empty property list with no default values.
`Properties(Properties defaults)` Creates an empty property list with the specified defaults.

Method Summary
`String` | `getProperty(String key)` Searches for the property with the specified key in this property list.
`String` | `getProperty(String key, String defaultValue)` Searches for the property with the specified key in this property list.
`void` | `list(PrintStream out)` Prints this property list out to the specified output stream.
`void` | `list(PrintWriter out)` Prints this property list out to the specified output stream.
`void` | `load(InputStream inStream)` Reads a property list (key and element pairs) from the input stream.
`Enumeration` | `propertyNames()` Returns an enumeration of all the keys in this property list, including distinct keys in the default property list if a key of the same name has not already been found from the main properties list.
`void` | `save(OutputStream out, String header)` Deprecated. This method does not throw an IOException if an I/O error occurs while saving the property list. As of the Java 2 platform v1.2, the preferred way to save a properties list is via the `store(OutputStream out, String header)` method.
`Object` | `setProperty(String key, String value)` Calls the `Hashtable` method `put`.
`void` | `store(OutputStream out, String header)` Writes this property list (key and element pairs) in this `Properties` table to the output stream in a format suitable for loading into a `Properties` table using the `load` method.

Methods inherited from class java.util.Hashtable
`clear, clone, contains, containsKey, containsValue, elements, entrySet, equals, get, hashCode, isEmpty, keys, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Properties

    public Properties()

  Creates an empty property list with no default values.

### Properties

    public Properties(Properties defaults)

  Creates an empty property list with the specified defaults.

  Parameters:
    `defaults` - the defaults.

Method Detail

### setProperty

    public Object setProperty(String key,
                              String value)

  Calls the `Hashtable` method `put`. Provided for parallelism with the `getProperty` method. Enforces use of strings for property keys and values. The value returned is the result of the `Hashtable` call to `put`.

  Parameters:
    `key` - the key to be placed into this property list.
    `value` - the value corresponding to `key`.
  Returns:
    the previous value of the specified key in this property list, or `null` if it did not have one.
  Since:
    1.2
  See Also:
    `getProperty(java.lang.String)`

### load

    public void load(InputStream inStream)
              throws IOException

  Reads a property list (key and element pairs) from the input stream. The stream is assumed to be using the ISO 8859-1 character encoding; that is each byte is one Latin1 character. Characters not in Latin1, and certain special characters, can be represented in keys and elements using escape sequences similar to those used for character and string literals (see §3.3 and §3.10.6 of the Java Language Specification). The differences from the character escape sequences used for characters and strings are:
  - Octal escapes are not recognized.
  - The character sequence `\b` does not represent a backspace character.
  - The method does not treat a backslash character, `\`, before a non-valid escape character as an error; the backslash is silently dropped. For example, in a Java string the sequence `"\z"` would cause a compile time error. In contrast, this method silently drops the backslash. Therefore, this method treats the two character sequence `"\b"` as equivalent to the single character `'b'`.
  - Escapes are not necessary for single and double quotes; however, by the rule above, single and double quote characters preceded by a backslash still yield single and double quote characters, respectively.
  An `IllegalArgumentException` is thrown if a malformed Unicode escape appears in the input.

  This method processes input in terms of lines. A natural line of input is terminated either by a set of line terminator characters (`\n` or `\r` or `\r\n`) or by the end of the file. A natural line may be either a blank line, a comment line, or hold some part of a key-element pair. The logical line holding all the data for a key-element pair may be spread out across several adjacent natural lines by escaping the line terminator sequence with a backslash character, `\`. Note that a comment line cannot be extended in this manner; every natural line that is a comment must have its own comment indicator, as described below. If a logical line is continued over several natural lines, the continuation lines receive further processing, also described below. Lines are read from the input stream until end of file is reached.

  A natural line that contains only white space characters is considered blank and is ignored. A comment line has an ASCII `'#'` or `'!'` as its first non-white space character; comment lines are also ignored and do not encode key-element information. In addition to line terminators, this method considers the characters space (`' '`, `'\u0020'`), tab (`'\t'`, `'\u0009'`), and form feed (`'\f'`, `'\u000C'`) to be white space.

  If a logical line is spread across several natural lines, the backslash escaping the line terminator sequence, the line terminator sequence, and any white space at the start the following line have no affect on the key or element values. The remainder of the discussion of key and element parsing will assume all the characters constituting the key and element appear on a single natural line after line continuation characters have been removed. Note that it is not sufficient to only examine the character preceding a line terminator sequence to to see if the line terminator is escaped; there must be an odd number of contiguous backslashes for the line terminator to be escaped. Since the input is processed from left to right, a non-zero even number of 2n contiguous backslashes before a line terminator (or elsewhere) encodes n backslashes after escape processing.

  The key contains all of the characters in the line starting with the first non-white space character and up to, but not including, the first unescaped `'='`, `':'`, or white space character other than a line terminator. All of these key termination characters may be included in the key by escaping them with a preceding backslash character; for example,

  `\:\=`

  would be the two-character key `":="`. Line terminator characters can be included using `\r` and `\n` escape sequences. Any white space after the key is skipped; if the first non-white space character after the key is `'='` or `':'`, then it is ignored and any white space characters after it are also skipped. All remaining characters on the line become part of the associated element string; if there are no remaining characters, the element is the empty string `""`. Once the raw character sequences constituting the key and element are identified, escape processing is performed as described above.

  As an example, each of the following three lines specifies the key `"Truth"` and the associated element value `"Beauty"`:

       Truth = Beauty
              Truth:Beauty
       Truth                  :Beauty

  As another example, the following three lines specify a single property:

       fruits                           apple, banana, pear, \
                                        cantaloupe, watermelon, \
                                        kiwi, mango

  The key is `"fruits"` and the associated element is:

      "apple, banana, pear, cantaloupe, watermelon, kiwi, mango"

  Note that a space appears before each `\` so that a space will appear after each comma in the final result; the `\`, line terminator, and leading white space on the continuation line are merely discarded and are not replaced by one or more other characters.

  As a third example, the line:

      cheeses

  specifies that the key is `"cheeses"` and the associated element is the empty string `""`.

  Parameters:
    `inStream` - the input stream.
  Throws:
    `IOException` - if an error occurred when reading from the input stream.
    `IllegalArgumentException` - if the input stream contains a malformed Unicode escape sequence.

### save

    public void save(OutputStream out,
                     String header)

  Deprecated. This method does not throw an IOException if an I/O error occurs while saving the property list. As of the Java 2 platform v1.2, the preferred way to save a properties list is via the `store(OutputStream out, String header)` method.

  Calls the `store(OutputStream out, String header)` method and suppresses IOExceptions that were thrown.

  Parameters:
    `out` - an output stream.
    `header` - a description of the property list.
  Throws:
    `ClassCastException` - if this `Properties` object contains any keys or values that are not `Strings`.

### store

    public void store(OutputStream out,
                      String header)
               throws IOException

  Writes this property list (key and element pairs) in this `Properties` table to the output stream in a format suitable for loading into a `Properties` table using the `load` method. The stream is written using the ISO 8859-1 character encoding.

  Properties from the defaults table of this `Properties` table (if any) are not written out by this method.

  If the header argument is not null, then an ASCII `#` character, the header string, and a line separator are first written to the output stream. Thus, the `header` can serve as an identifying comment.

  Next, a comment line is always written, consisting of an ASCII `#` character, the current date and time (as if produced by the `toString` method of `Date` for the current time), and a line separator as generated by the Writer.

  Then every entry in this `Properties` table is written out, one per line. For each entry the key string is written, then an ASCII `=`, then the associated element string. Each character of the key and element strings is examined to see whether it should be rendered as an escape sequence. The ASCII characters `\`, tab, form feed, newline, and carriage return are written as `\\`, `\t`, `\f` `\n`, and `\r`, respectively. Characters less than `\u0020` and characters greater than `\u007E` are written as `\u`xxxx for the appropriate hexadecimal value xxxx. For the key, all space characters are written with a preceding `\` character. For the element, leading space characters, but not embedded or trailing space characters, are written with a preceding `\` character. The key and element characters `#`, `!`, `=`, and `:` are written with a preceding backslash to ensure that they are properly loaded.

  After the entries have been written, the output stream is flushed. The output stream remains open after this method returns.

  Parameters:
    `out` - an output stream.
    `header` - a description of the property list.
  Throws:
    `IOException` - if writing this property list to the specified output stream throws an `IOException`.
    `ClassCastException` - if this `Properties` object contains any keys or values that are not `Strings`.
    `NullPointerException` - if `out` is null.
  Since:
    1.2

### getProperty

    public String getProperty(String key)

  Searches for the property with the specified key in this property list. If the key is not found in this property list, the default property list, and its defaults, recursively, are then checked. The method returns `null` if the property is not found.

  Parameters:
    `key` - the property key.
  Returns:
    the value in this property list with the specified key value.
  See Also:
    `setProperty(java.lang.String, java.lang.String)`, `defaults`

### getProperty

    public String getProperty(String key,
                              String defaultValue)

  Searches for the property with the specified key in this property list. If the key is not found in this property list, the default property list, and its defaults, recursively, are then checked. The method returns the default value argument if the property is not found.

  Parameters:
    `key` - the hashtable key.
    `defaultValue` - a default value.
  Returns:
    the value in this property list with the specified key value.
  See Also:
    `setProperty(java.lang.String, java.lang.String)`, `defaults`

### propertyNames

    public Enumeration propertyNames()

  Returns an enumeration of all the keys in this property list, including distinct keys in the default property list if a key of the same name has not already been found from the main properties list.

  Returns:
    an enumeration of all the keys in this property list, including the keys in the default property list.
  See Also:
    `Enumeration`, `defaults`

### list

    public void list(PrintStream out)

  Prints this property list out to the specified output stream. This method is useful for debugging.

  Parameters:
    `out` - an output stream.

### list

    public void list(PrintWriter out)

  Prints this property list out to the specified output stream. This method is useful for debugging.

  Parameters:
    `out` - an output stream.
  Since:
    JDK1.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD